#include <iostream>
#include <sstream>
#include "Parser.h"

// Zum Auslagern der Codegenerierung
void generateCode(Node *node, std::stringstream& strm);

int main()
{
	std::string input;

	while (true)
	{
		std::cout << "Eingabe: ";

		std::getline(std::cin, input);

		Parser p(input);

		// Baum generieren (Achtung: Speicher freigeben nicht vergessen!)
		Node *node = p.parse();

		std::cout << "\nErgebnis: " << node->eval() << "\n" << std::endl;

		std::stringstream strm;

		generateCode(node, strm);

		// Speicher freigeben
		delete node;

		std::cout << strm.str() << std::endl;
	}
}

void generateCode(Node *node, std::stringstream& strm)
{
	// Codegerst (anfang)
	strm << "#include <iostream>\n\n"

		 << "#define ADD(x, y) ((x) + (y))\n"
		 << "#define MUL(x, y) ((x) * (y))\n"
		 << "#define SUB(x, y) ((x) - (y))\n"
		 << "#define DIV(x, y) ((x) / (y))\n\n"

		 << "int main()\n"
		 << "{\n"
		 << "\tint res = ";

	// Den generierten Code vom Parser anhngen
	node->generateCode(strm);

	// Codegerst (ende)
	strm << " ;\n\n"
		 << "\tstd::cout << res << std::endl;\n"
		 << "\treturn 0;\n"
		 << "}\n";
}