#ifndef TOKEN_H
#define TOKEN_H

// Unsere Arten von Tokens
enum TokenType
{
    TT_PLUS, // +
    TT_MINUS, // -
    TT_MUL, // *
    TT_DIV, // /

    TT_LPAREN, // (
    TT_RPAREN, // )

    TT_NUMBER, // 12345

    TT_NIL // Kein passendes Token gefunden
};

// Unsere Arten von Tokens als String (Fr Fehlermeldungen)
static const char *TokenTypeStr[] = 
{
	"TT_PLUS",
	"TT_MINUS",
	"TT_MUL",
	"TT_DIV",

	"TT_LPAREN",
	"TT_RPAREN",

	"TT_NUMBER",

	"TT_NIL"
};

class Token
{
	private:
		TokenType myType;
		int myValue;

	public:
		Token(TokenType type = TT_NIL, int value = 0);

		TokenType getType() const { return myType; }
		int getValue() const { return myValue; }

		// Fr Fehlermeldungen
		const char *toString() const { return TokenTypeStr[myType]; }

		// Zum Vergleichen
		bool equal(TokenType type) const { return myType == type; }
};

#endif /* TOKEN_H */