#ifndef SCANNER_H
#define SCANNER_H

#include <string>
#include <vector>
#include "Token.h"

typedef std::vector<Token> TokenVec;

class Scanner
{
	private:
		std::string myInput;
		unsigned int myPos; // Aktuelle Position in Eingabe
		unsigned int myVecPos;
		char myCh; // Aktuelles Zeichen

		TokenVec myTokenVec; // Der Vector fr die Tokens

	public:
		Scanner(const std::string& input);

		Token getNextToken(bool peek = false);

	private:
		void initTokenVec();
		Token readNextToken();
		void skipSpaces();
		void readNextChar();
};

#endif /* SCANNER_H */